InputVerifier (Java Platform SE 8 )
Keywords: javax.swing.InputVerifier class
Date: 2023-01-18

javax.swing

## Class InputVerifier

- java.lang.Object
- - javax.swing.InputVerifier

-     public abstract class InputVerifier
      extends Object

  The purpose of this class is to help clients support smooth focus navigation through GUIs with text fields. Such GUIs often need to ensure that the text entered by the user is valid (for example, that it's in the proper format) before allowing the user to navigate out of the text field. To do this, clients create a subclass of `InputVerifier` and, using `JComponent`'s `setInputVerifier` method, attach an instance of their subclass to the `JComponent` whose input they want to validate. Before focus is transfered to another Swing component that requests it, the input verifier's `shouldYieldFocus` method is called. Focus is transfered only if that method returns `true`.

  The following example has two text fields, with the first one expecting the string "pass" to be entered by the user. If that string is entered in the first text field, then the user can advance to the second text field either by clicking in it or by pressing TAB. However, if another string is entered in the first text field, then the user will be unable to transfer focus to the second text field.

       import java.awt.*;
       import java.util.*;
       import java.awt.event.*;
       import javax.swing.*;

       // This program demonstrates the use of the Swing InputVerifier class.
       // It creates two text fields; the first of the text fields expects the
       // string "pass" as input, and will allow focus to advance out of it
       // only after that string is typed in by the user.

       public class VerifierTest extends JFrame {
           public VerifierTest() {
               JTextField tf1 = new JTextField ("Type \"pass\" here");
               getContentPane().add (tf1, BorderLayout.NORTH);
               tf1.setInputVerifier(new PassVerifier());

               JTextField tf2 = new JTextField ("TextField2");
               getContentPane().add (tf2, BorderLayout.SOUTH);

               WindowListener l = new WindowAdapter() {
                   public void windowClosing(WindowEvent e) {
                       System.exit(0);
                   }
               };
               addWindowListener(l);
           }

           class PassVerifier extends InputVerifier {
               public boolean verify(JComponent input) {
                   JTextField tf = (JTextField) input;
                   return "pass".equals(tf.getText());
               }
           }

           public static void main(String[] args) {
               Frame f = new VerifierTest();
               f.pack();
               f.setVisible(true);
           }
       }

  Since:
    1.3

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `InputVerifier()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `shouldYieldFocus(JComponent input)` Calls `verify(input)` to ensure that the input is valid.
    `abstract boolean` | `verify(JComponent input)` Checks whether the JComponent's input is valid.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### InputVerifier

          public InputVerifier()

  - ### Method Detail

    - #### verify

          public abstract boolean verify(JComponent input)

      Checks whether the JComponent's input is valid. This method should have no side effects. It returns a boolean indicating the status of the argument's input.
      Parameters:
        `input` - the JComponent to verify
      Returns:
        `true` when valid, `false` when invalid
      See Also:
        `JComponent.setInputVerifier(javax.swing.InputVerifier)`, `JComponent.getInputVerifier()`

    - #### shouldYieldFocus

          public boolean shouldYieldFocus(JComponent input)

      Calls `verify(input)` to ensure that the input is valid. This method can have side effects. In particular, this method is called when the user attempts to advance focus out of the argument component into another Swing component in this window. If this method returns `true`, then the focus is transfered normally; if it returns `false`, then the focus remains in the argument component.
      Parameters:
        `input` - the JComponent to verify
      Returns:
        `true` when valid, `false` when invalid
      See Also:
        `JComponent.setInputVerifier(javax.swing.InputVerifier)`, `JComponent.getInputVerifier()`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2023, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.